ClockFace {
	var <starttime, <tempo, <>inc, <cursecs, isPlaying = false, clock, <window, timeString;
	var remFun, <type;
	
	*new{ arg starttime = 0, tempo = 1, inc = 0.1, type = \minSecs;
		^super.newCopyArgs(starttime, tempo, inc).init(type);
		}
		
	init {arg argType;
		cursecs = starttime;
		this.digitalGUI;
		this.type_(argType);
		}
		
	play {
		var start;
		clock = TempoClock.new(tempo);
		start = clock.elapsedBeats;
		remFun = {this.stop};
		CmdPeriod.add(remFun);
		clock.sched(inc, {
			this.cursecs_(clock.elapsedBeats - start + starttime, false);
			inc;
			})
		}
		
	type_ {arg newType;
		(newType == \minSecs or: {newType == \secs}).if({
			type = newType
			}, {
			"Type should be \\minSecs or \\secs".warn;
			});
		this.cursecs_(cursecs); 
		}
		
	cursecs_ {arg curtime, updateStart = true;
		var curdisp;
		cursecs = curtime;
		case 
			{type == \secs}
			{curdisp = cursecs.round(0.01)}
			{type == \minSecs}
			{curdisp = cursecs.asTimeString;
			curdisp = curdisp[0 .. (curdisp.size-3)]}
			{true}
			{curdisp = cursecs.round(0.01)};
		updateStart.if({starttime = cursecs});
		{timeString.string_(curdisp)}.defer;
		}
		
	stop {
		starttime = cursecs;
		clock.clear;
		CmdPeriod.remove(remFun);
		clock.stop;
		}
		
	digitalGUI {
		window = GUI.window.new("Digital Clock", Rect(10, 250, 450, 110)).front;
		timeString = GUI.staticText.new(window, Rect(0, 0, 430, 100))
			.string_(cursecs.asTimeString)
			.font_(Font("Arial", 40));
		window.onClose_({this.stop});
		}

}

